import { Template, Builder } from "./types";
export declare abstract class BuilderBase<R> {
    private template;
    private underConstruction;
    constructor(template: Template<R>);
    build(): R;
    protected setScalar<F extends keyof R>(fieldName: F, value: R[F]): this;
    protected setNested<F extends keyof R, B extends Builder<R[F], Template<R[F]>>>(fieldName: F, builder: B, block: (builder: B) => any): this;
}
//# sourceMappingURL=builder.d.ts.map